
#include	<sys/types.h>
#include	<libgte.h>
#include	<libgpu.h>
#include	<libetc.h>
#include	<libgs.h>
#include	<libspu.h>
#include	<libmath.h>
#include	<hitmod.h>
#include	<pad.h>


//-------------------------
// div. Patcher Values :-)
//-------------------------

#define NOP		0x00000000
#define PAL		0x24020001
#define	NTSC		0x24020000



#define OT_LENGTH	13
#define PACKETMAX	4000
#define SCREEN_WIDTH	320
#define SCREEN_HEIGHT	240
#define	SCREEN_Z		(SCREEN_WIDTH+SCREEN_HEIGHT)/2
#define	rnd(max)	((rand()*(max))/(32768)+1)
u_long	pad;


//==============================
// STars....
//==============================
typedef struct{
	int x;					//star structure - has and x, y and z coordinate
	int y;
	int z;
	GsLINE line;				//GsLINE strcuture that make a star pixel
}Star;

#define MAX_STARS	200
#define star_w		7000			// determines the width of the area that stars 'appear' in
Star myStars[MAX_STARS];


GsOT myOT[2];
GsOT_TAG myOT_TAG[2][1<<OT_LENGTH];
PACKET GPUPacketArea[2][PACKETMAX*24];
int     Video_MODE=0;


//-------------------------
// Font-Sprites & Textures
//-------------------------
extern char font[];
#define		MAXCHAR	42
GsSPRITE	scroll[MAXCHAR];
GsSPRITE	fontspr[32*3];

//---------------------------------
// Laufschrifttext
//---------------------------------

#define	FONT_W	(8)
#define	FONT_H	(10)
int		anzfontabc=0; // , SinCount=0, Video_MODE=0;


char	fontabc[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789,.-+*#!\"%&/()=?;: ";

char	scrolltext[]="                                            "\
" THiS iS HiGH SOCieTY tO BRiNG YOU AN NeW iNTRO FOR YOUR PLeASURe"\
"                                           @";

void	setup_System(void);
void	init_Sprite(GsIMAGE*, GsSPRITE*);
void	set_ModePAL(void);
void	set_ModeNTSC(void);
void	do_All(int);


void	init_Typer(void);
void	do_Typer(void);
void	init_Page(int);

void	init_line(void);
void	do_line(void);

void	do_ShowBackground(void); //Hintergrundbilder
void 	do_Show1(void);

void	do_stars(void);
void	init_stars(void);

int	main(void);

//-------------------------
// Prototypes
//-------------------------
void	init_Scroll(void);
void	do_Scroll(void);

//---------------------------
// Globals fuer's Gfx-System
//---------------------------
int		actBuffer=0,delay=0,dmode=MODE_PAL;
int		test=0, i, LO=0;

GsGLINE		front_stars[150];	// Die vorderen Sterne
GsGLINE		stars[200];		// Die hinteger Sterne

//-------------------------
// Das Module Hitmen Format
//-------------------------
extern char	module[];

//-------------------------
// Die Logos
//-------------------------
extern char	lfc_logo[];	
extern char	crz_logo[];	

GsSPRITE	bground[2];
GsIMAGE		bgpart1;
GsIMAGE		bgpart2;

//---------------------------
// Lines
//---------------------------
GsGLINE		line[3];


//====================
// Die Sinustabellen
//====================

int SinTab1[1024]=
{ 2 , 4 , 7 , 9 , 11 , 13 , 15 , 18 ,
 20 , 22 , 24 , 26 , 28 , 30 , 32 , 34 ,
 36 , 38 , 40 , 42 , 44 , 46 , 48 , 50 ,
 52 , 54 , 55 , 57 , 59 , 60 , 62 , 64 ,
 65 , 67 , 68 , 70 , 71 , 72 , 74 , 75 ,
 76 , 77 , 78 , 79 , 80 , 81 , 82 , 83 ,
 84 , 85 , 85 , 86 , 87 , 87 , 88 , 88 ,
 89 , 89 , 89 , 90 , 90 , 90 , 90 , 90 ,
 90 , 90 , 90 , 90 , 89 , 89 , 89 , 88 ,
 88 , 87 , 87 , 86 , 85 , 85 , 84 , 83 ,
 82 , 81 , 80 , 79 , 78 , 77 , 76 , 75 ,
 74 , 72 , 71 , 70 , 68 , 67 , 65 , 64 ,
 62 , 60 , 59 , 57 , 55 , 54 , 52 , 50 ,
 48 , 46 , 44 , 42 , 40 , 38 , 36 , 34 ,
 32 , 30 , 28 , 26 , 24 , 22 , 20 , 18 ,
 15 , 13 , 11 , 9 , 7 , 4 , 2 , 0 ,
-2 ,-4 ,-7 ,-9 ,-11 ,-13 ,-15 ,-18 ,
-20 ,-22 ,-24 ,-26 ,-28 ,-30 ,-32 ,-34 ,
-36 ,-38 ,-40 ,-42 ,-44 ,-46 ,-48 ,-50 ,
-52 ,-54 ,-55 ,-57 ,-59 ,-60 ,-62 ,-64 ,
-65 ,-67 ,-68 ,-70 ,-71 ,-72 ,-74 ,-75 ,
-76 ,-77 ,-78 ,-79 ,-80 ,-81 ,-82 ,-83 ,
-84 ,-85 ,-85 ,-86 ,-87 ,-87 ,-88 ,-88 ,
-89 ,-89 ,-89 ,-90 ,-90 ,-90 ,-90 ,-90 ,
-90 ,-90 ,-90 ,-90 ,-89 ,-89 ,-89 ,-88 ,
-88 ,-87 ,-87 ,-86 ,-85 ,-85 ,-84 ,-83 ,
-82 ,-81 ,-80 ,-79 ,-78 ,-77 ,-76 ,-75 ,
-74 ,-72 ,-71 ,-70 ,-68 ,-67 ,-65 ,-64 ,
-62 ,-60 ,-59 ,-57 ,-55 ,-54 ,-52 ,-50 ,
-48 ,-46 ,-44 ,-42 ,-40 ,-38 ,-36 ,-34 ,
-32 ,-30 ,-28 ,-26 ,-24 ,-22 ,-20 ,-18 ,
-15 ,-13 ,-11 ,-9 ,-7 ,-4 ,-2 , 0 ,
 2 , 4 , 7 , 9 , 11 , 13 , 15 , 18 ,
 20 , 22 , 24 , 26 , 28 , 30 , 32 , 34 ,
 36 , 38 , 40 , 42 , 44 , 46 , 48 , 50 ,
 52 , 54 , 55 , 57 , 59 , 60 , 62 , 64 ,
 65 , 67 , 68 , 70 , 71 , 72 , 74 , 75 ,
 76 , 77 , 78 , 79 , 80 , 81 , 82 , 83 ,
 84 , 85 , 85 , 86 , 87 , 87 , 88 , 88 ,
 89 , 89 , 89 , 90 , 90 , 90 , 90 , 90 ,
 90 , 90 , 90 , 90 , 89 , 89 , 89 , 88 ,
 88 , 87 , 87 , 86 , 85 , 85 , 84 , 83 ,
 82 , 81 , 80 , 79 , 78 , 77 , 76 , 75 ,
 74 , 72 , 71 , 70 , 68 , 67 , 65 , 64 ,
 62 , 60 , 59 , 57 , 55 , 54 , 52 , 50 ,
 48 , 46 , 44 , 42 , 40 , 38 , 36 , 34 ,
 32 , 30 , 28 , 26 , 24 , 22 , 20 , 18 ,
 15 , 13 , 11 , 9 , 7 , 4 , 2 , 0 ,
-2 ,-4 ,-7 ,-9 ,-11 ,-13 ,-15 ,-18 ,
-20 ,-22 ,-24 ,-26 ,-28 ,-30 ,-32 ,-34 ,
-36 ,-38 ,-40 ,-42 ,-44 ,-46 ,-48 ,-50 ,
-52 ,-54 ,-55 ,-57 ,-59 ,-60 ,-62 ,-64 ,
-65 ,-67 ,-68 ,-70 ,-71 ,-72 ,-74 ,-75 ,
-76 ,-77 ,-78 ,-79 ,-80 ,-81 ,-82 ,-83 ,
-84 ,-85 ,-85 ,-86 ,-87 ,-87 ,-88 ,-88 ,
-89 ,-89 ,-89 ,-90 ,-90 ,-90 ,-90 ,-90 ,
-90 ,-90 ,-90 ,-90 ,-89 ,-89 ,-89 ,-88 ,
-88 ,-87 ,-87 ,-86 ,-85 ,-85 ,-84 ,-83 ,
-82 ,-81 ,-80 ,-79 ,-78 ,-77 ,-76 ,-75 ,
-74 ,-72 ,-71 ,-70 ,-68 ,-67 ,-65 ,-64 ,
-62 ,-60 ,-59 ,-57 ,-55 ,-54 ,-52 ,-50 ,
-48 ,-46 ,-44 ,-42 ,-40 ,-38 ,-36 ,-34 ,
-32 ,-30 ,-28 ,-26 ,-24 ,-22 ,-20 ,-18 ,
-15 ,-13 ,-11 ,-9 ,-7 ,-4 ,-2 , 0,
 2 , 4 , 7 , 9 , 11 , 13 , 15 , 18 ,
 20 , 22 , 24 , 26 , 28 , 30 , 32 , 34 ,
 36 , 38 , 40 , 42 , 44 , 46 , 48 , 50 ,
 52 , 54 , 55 , 57 , 59 , 60 , 62 , 64 ,
 65 , 67 , 68 , 70 , 71 , 72 , 74 , 75 ,
 76 , 77 , 78 , 79 , 80 , 81 , 82 , 83 ,
 84 , 85 , 85 , 86 , 87 , 87 , 88 , 88 ,
 89 , 89 , 89 , 90 , 90 , 90 , 90 , 90 ,
 90 , 90 , 90 , 90 , 89 , 89 , 89 , 88 ,
 88 , 87 , 87 , 86 , 85 , 85 , 84 , 83 ,
 82 , 81 , 80 , 79 , 78 , 77 , 76 , 75 ,
 74 , 72 , 71 , 70 , 68 , 67 , 65 , 64 ,
 62 , 60 , 59 , 57 , 55 , 54 , 52 , 50 ,
 48 , 46 , 44 , 42 , 40 , 38 , 36 , 34 ,
 32 , 30 , 28 , 26 , 24 , 22 , 20 , 18 ,
 15 , 13 , 11 , 9 , 7 , 4 , 2 , 0 ,
-2 ,-4 ,-7 ,-9 ,-11 ,-13 ,-15 ,-18 ,
-20 ,-22 ,-24 ,-26 ,-28 ,-30 ,-32 ,-34 ,
-36 ,-38 ,-40 ,-42 ,-44 ,-46 ,-48 ,-50 ,
-52 ,-54 ,-55 ,-57 ,-59 ,-60 ,-62 ,-64 ,
-65 ,-67 ,-68 ,-70 ,-71 ,-72 ,-74 ,-75 ,
-76 ,-77 ,-78 ,-79 ,-80 ,-81 ,-82 ,-83 ,
-84 ,-85 ,-85 ,-86 ,-87 ,-87 ,-88 ,-88 ,
-89 ,-89 ,-89 ,-90 ,-90 ,-90 ,-90 ,-90 ,
-90 ,-90 ,-90 ,-90 ,-89 ,-89 ,-89 ,-88 ,
-88 ,-87 ,-87 ,-86 ,-85 ,-85 ,-84 ,-83 ,
-82 ,-81 ,-80 ,-79 ,-78 ,-77 ,-76 ,-75 ,
-74 ,-72 ,-71 ,-70 ,-68 ,-67 ,-65 ,-64 ,
-62 ,-60 ,-59 ,-57 ,-55 ,-54 ,-52 ,-50 ,
-48 ,-46 ,-44 ,-42 ,-40 ,-38 ,-36 ,-34 ,
-32 ,-30 ,-28 ,-26 ,-24 ,-22 ,-20 ,-18 ,
-15 ,-13 ,-11 ,-9 ,-7 ,-4 ,-2 , 0 ,
 2 , 4 , 7 , 9 , 11 , 13 , 15 , 18 ,
 20 , 22 , 24 , 26 , 28 , 30 , 32 , 34 ,
 36 , 38 , 40 , 42 , 44 , 46 , 48 , 50 ,
 52 , 54 , 55 , 57 , 59 , 60 , 62 , 64 ,
 65 , 67 , 68 , 70 , 71 , 72 , 74 , 75 ,
 76 , 77 , 78 , 79 , 80 , 81 , 82 , 83 ,
 84 , 85 , 85 , 86 , 87 , 87 , 88 , 88 ,
 89 , 89 , 89 , 90 , 90 , 90 , 90 , 90 ,
 90 , 90 , 90 , 90 , 89 , 89 , 89 , 88 ,
 88 , 87 , 87 , 86 , 85 , 85 , 84 , 83 ,
 82 , 81 , 80 , 79 , 78 , 77 , 76 , 75 ,
 74 , 72 , 71 , 70 , 68 , 67 , 65 , 64 ,
 62 , 60 , 59 , 57 , 55 , 54 , 52 , 50 ,
 48 , 46 , 44 , 42 , 40 , 38 , 36 , 34 ,
 32 , 30 , 28 , 26 , 24 , 22 , 20 , 18 ,
 15 , 13 , 11 , 9 , 7 , 4 , 2 , 0 ,
-2 ,-4 ,-7 ,-9 ,-11 ,-13 ,-15 ,-18 ,
-20 ,-22 ,-24 ,-26 ,-28 ,-30 ,-32 ,-34 ,
-36 ,-38 ,-40 ,-42 ,-44 ,-46 ,-48 ,-50 ,
-52 ,-54 ,-55 ,-57 ,-59 ,-60 ,-62 ,-64 ,
-65 ,-67 ,-68 ,-70 ,-71 ,-72 ,-74 ,-75 ,
-76 ,-77 ,-78 ,-79 ,-80 ,-81 ,-82 ,-83 ,
-84 ,-85 ,-85 ,-86 ,-87 ,-87 ,-88 ,-88 ,
-89 ,-89 ,-89 ,-90 ,-90 ,-90 ,-90 ,-90 ,
-90 ,-90 ,-90 ,-90 ,-89 ,-89 ,-89 ,-88 ,
-88 ,-87 ,-87 ,-86 ,-85 ,-85 ,-84 ,-83 ,
-82 ,-81 ,-80 ,-79 ,-78 ,-77 ,-76 ,-75 ,
-74 ,-72 ,-71 ,-70 ,-68 ,-67 ,-65 ,-64 ,
-62 ,-60 ,-59 ,-57 ,-55 ,-54 ,-52 ,-50 ,
-48 ,-46 ,-44 ,-42 ,-40 ,-38 ,-36 ,-34 ,
-32 ,-30 ,-28 ,-26 ,-24 ,-22 ,-20 ,-18 ,
-15 ,-13 ,-11 ,-9 ,-7 ,-4 ,-2 , 0 };



//-------------------------
// Font-Sprites & Textures
//-------------------------
extern char 	font[];
#define		PAGEW	(25)
#define		PAGEH	(9)

#define		ZEICHEN1	(32)	// <--- Wieviele Zeichen sind in EINER Reihe vom FONT ?
#define		ZEILEN1	(3)	// <--- Wieviele Reihen sind im FONT ?
#define		MAX_CHAR	(PAGEH*PAGEW)

GsSPRITE	fontspr1[ZEICHEN1 * ZEILEN1];
GsSPRITE	page[MAX_CHAR];




//---------------------------------
// ABC-Tabelle und Laufschrifttext
//---------------------------------
#define	FONT_W1	(8)
#define	FONT_H1	(10)
int	anzfontabc1=0, SinCount=0;

static int isinit=0;
char	fontabc1[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789,.-+*#!\"%&/()=?;: ";


//-----------------------
// Anzahl der Textseiten
//-----------------------
#define PAGES	3

//-------------------------------
// die Textseite
//-------------------------------
char texte[PAGEH*PAGES][PAGEW]=

{
    {"                         "},
    {"         H I G H         "},
    {"      S O C I E T Y      "},
    {"                         "},
    {"  are Proud to Presents  "},
    {"                         "},
    {"    an New PSX Intro     "},
    {"                         "},
    {"                         "},

    {"                         "},
    {"   Watch out for more    "},
    {"                         "},
    {"     Quality Releses     "},
    {"                         "},
    {"          from           "},
    {"                         "},
    {"       HIGH SOCIETY      "},
    {"                         "},

    {"                         "},
    {"                         "},
    {"                         "},
    {"   nothing more to say   "},
    {"                         "},
    {"      signed: crazy      "},
    {"                         "},
    {"                         "},
    {"                         "},

};


//
//===============
// Hauptprogramm
//===============
//
int main()
{
	u_long	*ficken;

	//--------------------------------------------
	// Videomode setzen und Grafik initialisieren
	//--------------------------------------------
	setup_System();
	init_stars();

	//============================
	// die lines initialisieren
	//============================
	       init_line();

	//-------------------------------
	// init Sprites for the Scroller
	//-------------------------------
	init_Scroll();

	init_Typer();

	//-------------------------------------------
	// das logo
	//--------------------------------------------

	GsGetTimInfo((u_long *)(crz_logo+4), &bgpart2);	// init Background Sprite 1
	init_Sprite(&bgpart2, &bground[1]);
	bground[1].x=295;				bground[1].y=10;

	GsGetTimInfo((u_long *)(lfc_logo+4), &bgpart1);	// init Background Sprite 1
	init_Sprite(&bgpart1, &bground[0]);
	bground[0].x=160;				bground[0].y=120;

	//--------------------------------------------
	// Die mukke !..megaaawichtiiiig =)
	//--------------------------------------------
	MOD_Init();
	MOD_Load((unsigned char*)module);
	MOD_Start();
	
	//---------------
	// Hauptschleife
	//---------------
	for(;;)
	{
		if(++delay==5)	delay=0;
		pad=PadRead(0);
	
		//-----------------------------
		// Darstellungsparameter holen
		//-----------------------------
		actBuffer=GsGetActiveBuff();						// get the current buffer
		GsSetWorkBase((PACKET*)GPUPacketArea[actBuffer]);			// Setup the packet workbase
		GsClearOt(0,0,&myOT[actBuffer]);					// clear the ordering table


		//=============================
		// Sterne am Himmel
		//=============================
                  do_stars();

		//=============================
		// Die line erzeugen
		//=============================
		  do_line();

		//=============================
		// den Typer starten
		//=============================
		  do_Typer();

		//-----------------------
		// draw Scroller-Sprites 
		//-----------------------
		do_Scroll();


		//=============================
		// Hintergrundsprite darstellen
		//=============================
		do_ShowBackground();  	

		//--------------------------------------
		// und ab geht die post !!!
		//--------------------------------------
		do_All(actBuffer);

 		if(pad&Pad1x){Video_MODE=1; break;	}
		if(pad&Pad1crc){Video_MODE=2; break;	}

}

	//------------------------------
	// alles auschalten und beenden
	//------------------------------
	SpuInit();
	SpuQuit();
 	MOD_Stop();
 	MOD_Free();

	//--------------------------------------
	// ab HIER kann man alles andere machen
	//--------------------------------------
	PadStop();
	ResetGraph(0);
	StopCallback();

	//-----------------
	// Spiel entpacken
	//-----------------
	EnterCriticalSection();
	depack1();
	ExitCriticalSection();

	//------------------------------------------------
	// hier den Patch reinmachen Video_MODE==1 (PAL)
	//			     Video_MODE==2 (NTSC)
	//------------------------------------------------

        if(Video_MODE==1)
        {
          ficken = (u_long *)0x8005712c;         *ficken = 0x24020001; // Get Video
          ficken = (u_long *)0x80057130;         *ficken = NOP;        // Get Video

          ficken = (u_long *)0x80055038;         *ficken = 0x24900030; // X-Delta
          ficken = (u_long *)0x8005503c;         *ficken = 0x24900030; // X-Delta
        }

	//---------------
	// starts game
	//---------------
	asm("nop");
  	asm("j 0x800110a4"); // ExecAdress
  	asm("nop");
}

//=========================
// Init Starfield
//=========================
void	init_stars()
{

	static int 	i;

	//==================================
	// Foreground Stars
	//==================================
	for(i=0;i<150;i++)

	 {
	  front_stars[i] = stars[0] ;
	  front_stars[i].x0 = front_stars[i].x1 = rnd(320) ;
          front_stars[i].y0 = front_stars[i].y1 = 2 + rnd(235);
	  front_stars[i].r0 = front_stars[i].g0 = front_stars[i].b0 = 155; // Farbe RBG
	  front_stars[i].r1 = front_stars[i].g1 = front_stars[i].b1 = 155; // Farbe RBG
	 }


	//==================================
	// Background Stars
	//==================================
	for(i=0;i<200;i++)

	 {
	  stars[i] = stars[0] ;
	  stars[i].x0 = stars[i].x1 = rnd(320) ;        
	  stars[i].y0 = stars[i].y1 = 2 + rnd(235);			//316
	  stars[i].r0 = stars[i].g0 = stars[i].b0 = 133; // Farbe RBG
	  stars[i].r1 = stars[i].g1 = stars[i].b1 = 133; // Farbe RBG
	 }
}


//========================
// Do Starfield
//========================
void	do_stars()
{
	static int 	i;

	//===================================
	// Foreground Stars
	//===================================
	for(i=0;i<150;i++)
	 {

	  front_stars[i].x0 = front_stars[i].x1+=2;
	  if(front_stars[i].x0 > 320)
	   {
            front_stars[i].x0 = front_stars[i].x1 = 0 ;
 	   }
	  GsSortGLine(&front_stars[i],&myOT[actBuffer],0);
	 }


	//===================================
	// Background Stars
	//===================================
	for(i=0;i<200;i++)
	 {
	  stars[i].x0 = stars[i].x1+=1;

	  if(stars[i].x0 > 320)
	   {
            stars[i].x0 = stars[i].x1 = 0 ;
 	   }
	  GsSortGLine(&stars[i],&myOT[actBuffer],0);
	 }
}

//
//======================================
// Hintergrundbild (Drehen und zoomen)
//======================================

void do_ShowBackground()

{
	bground[0].rotate+=ONE*2;

	if((LO==0) && (bground[0].scalex<=7500))	// 7500
	{
	 bground[0].scalex+=64;

		if(bground[0].scalex>=7500){ LO=1;}
	}


	if((LO==1) && (bground[0].scalex>=-5000)) // 5000
	{
	 bground[0].scalex-=64;

		if(bground[0].scalex<= -5000) {LO=0;}
	}

	SinCount++;	
	if(SinCount==511) SinCount=0; //511
	{	
	bground[0].x=160 + ( SinTab1[SinCount +i] /1);
	}

 	GsSortSprite(&bground[1], &myOT[actBuffer], 0);
 	GsSortSprite(&bground[0], &myOT[actBuffer], 0);
}

//
//======================
// PAL Modus aktivieren
//======================
//
void set_ModePAL()
{
	if(dmode!=MODE_PAL)
	{
		DrawSync(0);
		VSync(0);
		SetVideoMode(MODE_PAL);
		ResetGraph(0);
		GsInitGraph(SCREEN_WIDTH, SCREEN_HEIGHT, GsNONINTER|GsOFSGPU, 0,0);
		GsDefDispBuff(0,0,0,SCREEN_HEIGHT);
		dmode=MODE_PAL;
	}
}
//
//=======================
// NTSC Modus aktivieren
//=======================
//
void set_ModeNTSC()
{
	if(dmode!=MODE_NTSC)
	{
		DrawSync(0);
		VSync(0);
		SetVideoMode(MODE_NTSC);
		ResetGraph(0);
		GsInitGraph(SCREEN_WIDTH, SCREEN_HEIGHT, GsNONINTER|GsOFSGPU, 0,0);
		GsDefDispBuff(0,0,0,SCREEN_HEIGHT);
		dmode=MODE_NTSC;
	}
}


//
//=============================
// Font-Sprites initialisieren
//=============================
//
void init_Scroll()
{
	GsIMAGE	fontimg;
	int	i=0,j=0,k=0;
	unsigned char	fontxy[32*3*2];
	anzfontabc=strlen(fontabc);
	//------------------------------------------
	// calculate X+Y Offsets within Texturepage
	//------------------------------------------
	for(i=0;i<3;i++)
	{
		for(j=0;j<32;j++)
		{
			fontxy[k++]=(j*FONT_W);	// X Offset
			fontxy[k++]=(i*FONT_H);	// Y Offset
		}
	}
	//----------------------------------
	// now init Texture and all Sprites
	//----------------------------------
	GsGetTimInfo((u_long *)(font+4), &fontimg);
	init_Sprite(&fontimg, &fontspr1[0]);
	j=0;
	fontspr1[0].w=FONT_W1;
	fontspr1[0].h=FONT_H1;
	fontspr1[0].u=fontxy[j++];
	fontspr1[0].v=fontxy[j++];
	fontspr1[0].y=120;
	for(i=1;i<anzfontabc;i++)
	{
		fontspr1[i]=fontspr1[0];
		fontspr1[i].u=fontxy[j++];
		fontspr1[i].v=fontxy[j++];
	}
}


//
//===========================
// Draw the Scroller-Sprites
//===========================
//
void do_Scroll()
{
	int	i,j;
	static int step,scrpos;

	//--------------------------------------
	// die entsprechenden Sprites berechnen
	//--------------------------------------
	for(i=0;i<MAXCHAR;i++)
	{
		for(j=0;j<anzfontabc;j++)
		{
			if(scrolltext[scrpos+i]!='@')
			{
				if(scrolltext[scrpos+i]==fontabc[j])
				{
					scroll[i]=fontspr1[j];
					scroll[i].x=(i*FONT_W1)-step;
				}
			}
			else
			{
				scrpos=0;
			}
		}
	}
	//----------------------------------------------------------
	// Zeichen bei naechster Darstellung nach links verschieben
	//----------------------------------------------------------
	if(++step==FONT_W1)
	{
		scrpos++;
		step=0;
	}
//--------------------------------
// insert Scrollersprites into OT
//--------------------------------

	SinCount++;	
	if(SinCount==511) SinCount=0;	for(i=0;i<MAXCHAR;i++)
	for(i=0;i<MAXCHAR;i++)
	{	


//=============================
// Scroller aufblinken lassen
//=============================
	
	scroll[i].r=rnd(255);
//	if(delay==0){scroll[i].g=rnd(255);}
	scroll[i].b=rnd(255);


	scroll[i].y=120 + ( SinTab1[SinCount +i] /1);

	GsSortFastSprite(&scroll[i], &myOT[actBuffer], 0);
	}

//	{
//	GsSortFastSprite(&scroll[i], &myOT[actBuffer], 0);
//	}
}

//
//=============================
// Grafiksystem initialisieren
//=============================
//
void setup_System()
{
	if (*(char *)0xbfc7ff52=='E')	// E(urope) --> PAL; A(merica) and J(apan) both use NTSC
	{
		dmode=MODE_PAL;
	}
	else
	{
		dmode=MODE_NTSC;
	}
	SetVideoMode(dmode);
	ResetGraph(0);
	GsInitGraph(SCREEN_WIDTH, SCREEN_HEIGHT, GsNONINTER|GsOFSGPU, 0,0);
	GsDefDispBuff(0,0,0,SCREEN_HEIGHT);
	myOT[0].length=OT_LENGTH;
	myOT[1].length=OT_LENGTH;
	myOT[0].org=myOT_TAG[0];
	myOT[1].org=myOT_TAG[1];
	GsClearOt(0,0,&myOT[0]);
	GsClearOt(0,0,&myOT[1]);
	FntLoad(960, 256);
	FntOpen(10,10,SCREEN_WIDTH-10,SCREEN_HEIGHT-20,0,512);
	SetDispMask(1);
	PadInit(0);
}
//
//============================================
// Display aktualisieren und alles darstellen
//============================================
//
void do_All(int mybuffer)
{
	FntFlush(-1);
	DrawSync(0);									// Wait for all drawing to finish
	VSync(0);										// wait for V_BLANK interrupt
	GsSwapDispBuff();								// flip double buffers
	GsSortClear(0, 0, 0,&myOT[mybuffer]);				// Clear the Ordering Table with a background color
	GsDrawOt(&myOT[mybuffer]);						// Draw the ordering table for the actBuffer
}




//
//=================================
// Sprite & Texture initialisieren
//=================================
//
void init_Sprite(GsIMAGE *im, GsSPRITE *sp)
{
	int bits;
	int widthCompression;
	RECT myRect;
	//----------------------------
	// Bit-Mode des Sprites holen
	//----------------------------
	bits=im->pmode&0x03;
	if		(bits==0)	widthCompression=4;
	else if (bits==1)	widthCompression=2;
	else if (bits==2)	widthCompression=1;
	else if (bits==3)
	{
		printf("\nunsupported file format (24bit tim)!\n");
		exit(-1);
	}
	//-------------------------------
	// Grafikdaten ins VRAM kopieren
	//-------------------------------
	myRect.x=im->px;
	myRect.y=im->py;
	myRect.w=im->pw;
	myRect.h=im->ph;
	LoadImage(&myRect,im->pixel);
	//--------------------------
	// diverse Attribute setzen
	//--------------------------
	sp->attribute=(bits<<24);
	sp->x=SCREEN_WIDTH/2-((im->pw*widthCompression)/2);	//center sprite's x value
	sp->y=SCREEN_HEIGHT/2-im->ph/2;						//center sprite's y value
	sp->w=im->pw*widthCompression;
	sp->h=im->ph;
	sp->tpage=GetTPage(bits,0,im->px,im->py);
	sp->u=0;
	sp->v=0;
	sp->r=128;
	sp->g=128;
	sp->b=128;
	sp->mx=(im->pw*widthCompression)/2;
	sp->my=im->ph/2;
	sp->scalex=ONE;
	sp->scaley=ONE;
//	sp->rotate=20*ONE;
	//-----------------------------------------------------------
	// wenn 4bit oder 8bit Grafik, dann auch CLUT Daten kopieren
	//-----------------------------------------------------------
	if (bits==0||bits==1)
	{
		myRect.x=im->cx;
		myRect.y=im->cy;
		myRect.w=im->cw;
		myRect.h=im->ch;
		LoadImage(&myRect,im->clut);
		sp->cx=im->cx;
		sp->cy=im->cy;
	}
}


//
//===========================
// Typer Font initialisieren
//===========================
//
void init_Typer()
{
	GsIMAGE	fontimg;
	int	i=0,j=0,k=0;
	unsigned char	fontxy[ZEICHEN1*ZEILEN1*2];
	anzfontabc1=strlen(fontabc1);
	//--------------------------------------------
	// X+Y Offsets innerhalb der Textur berechnen
	//--------------------------------------------
	for(i=0;i<ZEILEN1;i++)
	{
		for(j=0;j<ZEICHEN1;j++)
		{
			fontxy[k++]=(j*FONT_W1);	// X Offset
			fontxy[k++]=(i*FONT_H1);	// Y Offset
		}
	}
	//---------------------------------------
	// Textur und alle Sprites initialisieren
	//----------------------------------------
	GsGetTimInfo((u_long *)(font+4), &fontimg);
	init_Sprite(&fontimg, &fontspr[0]);
	j=0;
	fontspr[0].w=FONT_W1;
	fontspr[0].h=FONT_H1;
	fontspr[0].u=fontxy[j++];
	fontspr[0].v=fontxy[j++];
	for(i=1;i<anzfontabc;i++)
	{
		fontspr[i]=fontspr[0];
		fontspr[i].u=fontxy[j++];
		fontspr[i].v=fontxy[j++];
	}
}

//
//================
// Typer ausgeben
//================
//
void do_Typer()
{
	static int	act_x=0,act_y=0,act_p=0;
	static int	charcnt=0,delaycnt=50*10,
				clrcount=122;
	int	i=0,subit=-2;
	//charcnt=MAX_CHAR;
	//-----------------------------
	// soll Seite gelscht werden?
	//-----------------------------
	if(clrcount==122)
	{
		//---------------------------------------------------------------------
		// wenn aktuelle Seite noch nicht initialisiert ist, dann jetzt machen
		//---------------------------------------------------------------------
		if(isinit==0)
		{
			init_Page(act_p);
			isinit++;
			
		}
		//-----------------------------------
		// die Seite Zeichenweise darstellen
		//-----------------------------------
		for(i=0;i<charcnt;i++)
		{
		page[i].r =000;
		page[i].g =000;
		page[i].b =000;

//		page[i].r =255;
//		page[i].g =255;
//		page[i].b =255;

			GsSortFastSprite(&page[i],&myOT[actBuffer],0);
		}
		//-------------------------------------------------------
		// wenn noch nicht alle Zeichen da, dann noch eines dazu
		//-------------------------------------------------------
		if(charcnt<MAX_CHAR)
		{
			charcnt++;
		}
		//----------------------------------------------------
		// ok, alle da... also warten und dann Seite loeschen
		//----------------------------------------------------
		else
		{
			if(--delaycnt==0)
			{
				delaycnt=50*10;
				clrcount--;
 			}
		}
	}
	//----------------------
	// ok, neue Seite holen
	//----------------------
	else
	{
		if(++act_p==PAGES)	act_p=0;
		charcnt=0;
		isinit=0;
		clrcount=122;
	}
}

//
//==================================================
// hier wird das Sprite-Array fr den Typer gefllt
//==================================================
//
void init_Page(int pagenum)
{
	int	h,i,j,k=0;
	//--------------------------------------
	// die entsprechenden Sprites berechnen
	//--------------------------------------
	for(h=0;h<PAGEH;h++)
	{
		for(i=0;i<PAGEW;i++)
		{
			for(j=0;j<anzfontabc;j++)
			{
				//-------------------------------------------------
				// wenn SPACE dann Sprite einfach nicht darstellen
				//-------------------------------------------------
				if(texte[h+(PAGEH*pagenum)][i]==' ')
				{
					page[k++].w=0;
					break;
				}
				//------------------------------------------------
				// den Buchstaben entsprechendes Sprite eintragen
				//------------------------------------------------
				if(texte[h+(PAGEH*pagenum)][i]==fontabc[j])
				{
					page[k  ]=fontspr1[j];
					page[k  ].x=70+(i*FONT_W1);
					page[k++].y=60+(h*FONT_H1)+12; //y position vom typer! 
					break;
				}
			}
		}
	}
}

// ---------

//===============================================
// initialisiere die lines (pos + rgb)
//===============================================
void init_line()
{
	line[0].x0=0;
	line[0].y0=0;
	line[0].x1=320;
	line[0].y1=0;

	line[0].r0=155;
	line[0].g0=155;
	line[0].b0=151;

	line[1].x0=320;
	line[1].y0=239;
	line[1].x1=0;
	line[1].y1=239;

	line[1].r0=151;
	line[1].g0=155;
	line[1].b0=155;

}


//======================================================
// zeichne mir die liiiiiineeeeeeesssssssss =)
//======================================================
void do_line()
{	
	GsSortLine(&line[0],&myOT[actBuffer],0);

//=========================
// Farben der oberen linie

	if(delay==0){	line[0].r0=rnd(255);}
	if(delay==0){	line[0].g0=rnd(255);}
	if(delay==0){	line[0].b0=rnd(255);}

	GsSortLine(&line[1],&myOT[actBuffer],0);

//=========================
// Farben der unteren linie

	if(delay==0){	line[1].r0=rnd(255);}
	if(delay==0){	line[1].g0=rnd(255);}
	if(delay==0){	line[1].b0=rnd(255);}
}
